#include "Wave.h"

int export_sample(AL_CONST char* filename, SAMPLE* spl)
{
    int bps = spl->bits / 8 * ((spl->stereo) ? 2 : 1);
    int len = spl->len * bps;
    int i;
    signed short s;
    PACKFILE* f;
    
    f = pack_fopen(filename, F_WRITE);
    
    if(f)
    {
        pack_fputs("RIFF",f);
        pack_iputl(36+len,f);
        pack_fputs("WAVE",f);
        pack_fputs("fmt ",f);
        pack_iputl(16,f);
        pack_iputw(1,f);
        pack_iputw((spl->stereo) ? 2 : 1, f);
        pack_iputl(spl->freq, f);
        pack_iputl(spl->freq * bps, f);
        pack_iputw(bps, f);
        pack_iputw(spl->bits, f);
        //HEADER ENDE
        
        pack_fputs("data", f);
        pack_iputl(len, f);
        if(spl->bits == 8)
            pack_fwrite(spl->data, len, f);
        else
            for(int i = 0; i < (int) spl->len * ((spl->stereo) ? 2 : 1); i++)
            {
                s = ((signed short*)spl->data)[i];
                pack_iputw(s^0x8000, f);   
            }
        pack_fclose(f);
    }   
    return (errno == 0);
}
