#include "usynthesizer.h"


#define IsTone(a) (((a) & 0xC0) == 0)

//von 'A bis c'''' 64 tne; Angaben in 44100/Freq, gerundet                  
unsigned short Freq[] = {
//c  cis   d   dis   e    f   fis   g   gis   a  ais/b  h
                                             802, 757, 714, //'X
674, 636, 601, 567, 535, 505, 477, 450, 425, 401, 378, 357, // X
337, 318, 300, 283, 268, 253, 238, 225, 212, 200, 189, 179, // x
169, 159, 150, 142, 134, 126, 119, 113, 106, 100,  95,  89, // x'
 84,  80,  75,  71,  67,  63,  60,  56,  53,  50,  47,  45, // x''
 42,  40,  38,  35,  33,  32,  30,  28,  27,  25,  24,  22, // x'''
 21                                                         // x''''
                    };
                

unsigned char* array;
unsigned char channels;
Channel* channel;

                
void RegisterArray(unsigned char* Array)
{
    array = Array;
    channels = array[0];
    channel = new Channel[channels];
    printf("MIDI - Array registered:\nChannels: %d\n", channels);
    channel[0].pos = channels * 2 + 1 - 1; //Pos ist Standardmg 1 kleiner, da in der GetChannelfunktion, der erste Befehl bersprungen wird
    for(unsigned char i = 0, dir = 1; i < channels; i++, dir += 2)
    {
        unsigned char a = 0, b = 0;
        if(i)
            channel[i].pos = channel[i - 1].len - 1; //Pos ist eins kleiner
        channel[i].len = (array[dir] << 8) + array[dir + 1] + channel[i].pos + 1; //Darf Len aber nicht verflschen
        for(int c = channel[i].pos; c < channel[i].len; c++)
            if(IsTone(array[c]))
                a++;
            else
                b++;
        printf("Channel %d: Begins at %d, ends at %d, notes: %d, commands: %d\n", i, channel[i].pos + 1, channel[i].len, a, b);
    }
}
unsigned char GetMix()
{
    unsigned short mixed = 0;
    for(unsigned char i = 0; i < channels; i++)
        mixed += GetChannel(i);
    mixed /= channels;
    return mixed;
}

unsigned char GetChannel(unsigned char i)
{
    if(channel[i].pos >= channel[i].len)
        return 128;
    if(++channel[i].tonepos >= channel[i].tonelen)
    {
        channel[i].tonepos = 0;
        channel[i].freqpos = 0;
        //Neuer Ton
        unsigned char value;
        while(!IsTone(value = array[++channel[i].pos]))
        {
            switch(value & 0xC0)
            {
                case 0xC0: channel[i].tonelen = (1 << (7 - (value & 0x07))) * 44100 / 128 * 2;
                    printf("Channel %d (%d / %d): New Tone-Len: %d\n",i,channel[i].pos, channel[i].len, channel[i].tonelen);
                    break;
                default: printf("Channel %d (%d / %d): Error: Unknown command: %d\n",i,channel[i].pos, channel[i].len, value & 0xC0);
            };
        }
        
        channel[i].freq = Freq[array[channel[i].pos]];
        printf("Channel %d (%d / %d): New Tone: %d\n", i,channel[i].pos, channel[i].len,array[channel[i].pos]);
    }
    if(++channel[i].freqpos >= channel[i].freq)
        channel[i].freqpos = 0;
    else
    {
        if(channel[i].freqpos > channel[i].freq / 2)
            return 255 - channel[i].tonevol;
        return channel[i].tonevol;
    }
}

